<template>
  <div class="koi-flex">
    <KoiCard>
      <!-- 搜索条件 -->
      <el-form v-show="showSearch" :inline="true">
        <el-form-item label="岗位名称" prop="postName">
          <el-input
            placeholder="请输入岗位名称"
            v-model="searchParams.postName"
            clearable
            style="width: 240px"
            @keyup.enter.native="handleListPage"
          ></el-input>
        </el-form-item>
        <el-form-item label="岗位编码" prop="postCode">
          <el-input
            placeholder="请输入岗位编码"
            v-model="searchParams.postCode"
            clearable
            style="width: 240px"
            @keyup.enter.native="handleListPage"
          ></el-input>
        </el-form-item>
        <el-form-item label="岗位状态" prop="status">
          <el-select
            placeholder="请选择岗位状态"
            v-model="searchParams.status"
            clearable
            style="width: 240px"
            @keyup.enter.native="handleListPage"
          >
            <el-option
              v-for="dict in koiDicts.sys_normal_disable"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            />
          </el-select>
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="search" plain v-debounce="handleSearch">搜索</el-button>
          <el-button type="danger" icon="refresh" plain v-throttle="resetSearch">重置</el-button>
        </el-form-item>
      </el-form>

      <!-- 表格头部按钮 -->
      <el-row :gutter="10">
        <el-col :span="1.5" v-auth="['system:post:add']">
          <el-button type="primary" icon="plus" plain @click="handleAdd()">新增</el-button>
        </el-col>
        <el-col :span="1.5" v-auth="['system:post:edit']">
          <el-button type="success" icon="edit" plain @click="handleUpdate()" :disabled="single">修改</el-button>
        </el-col>
        <el-col :span="1.5" v-auth="['system:post:remove']">
          <el-button type="danger" icon="delete" plain @click="handleDelete()" :disabled="multiple">删除</el-button>
        </el-col>
        <el-col :span="1.5" v-auth="['system:post:export']" @click="handleExport">
          <el-button type="warning" icon="download" plain>导出</el-button>
        </el-col>
        <KoiToolbar v-model:showSearch="showSearch" @refreshTable="handleListPage"></KoiToolbar>
      </el-row>

      <div class="h-20px"></div>
      <!-- 数据表格 -->
      <el-table
        v-loading="loading"
        border
        :data="tableList"
        empty-text="暂时没有数据哟"
        @selection-change="handleSelectionChange"
      >
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="序号" prop="postId" width="80px" align="center" type="index"></el-table-column>
        <el-table-column label="岗位名称" prop="postName" align="center" :show-overflow-tooltip="true"></el-table-column>
        <el-table-column label="岗位编码" prop="postCode" width="130px" align="center" :show-overflow-tooltip="true"></el-table-column>
        <el-table-column label="部门状态" prop="status" width="100px" align="center">
          <template #default="scope">
            <KoiTag :tagOptions="koiDicts.sys_normal_disable" :value="scope.row.status"></KoiTag>
          </template>
        </el-table-column>
        <el-table-column label="显示顺序" prop="postSort" width="100px" align="center" :show-overflow-tooltip="true"
        ></el-table-column>
        <el-table-column label="创建时间" prop="createTime" width="180px" align="center"></el-table-column>
        <el-table-column label="创建人" prop="createBy" width="150px" align="center"></el-table-column>
        <el-table-column label="修改人" prop="updateBy" width="150px" align="center"></el-table-column>
        <el-table-column label="修改时间" prop="updateTime" width="180px" align="center"></el-table-column>
        <el-table-column label="岗位备注" prop="remark" width="220px" align="center" :show-overflow-tooltip="true"></el-table-column>
        <el-table-column label="操作" align="center" width="120" fixed="right">
          <template #default="{ row }">
            <el-tooltip content="修改" placement="top">
              <el-button
                type="primary"
                icon="Edit"
                circle
                plain
                @click="handleUpdate(row)"
                v-auth="['system:role:update']"
              ></el-button>
            </el-tooltip>
            <el-tooltip content="删除" placement="top">
              <el-button
                type="danger"
                icon="Delete"
                circle
                plain
                @click="handleDelete(row)"
                v-auth="['system:role:delete']"
              ></el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>

      <div class="h-20px"></div>
      <!-- 分页 -->
      <Pagination :queryParams="searchParams" :total="total" :getList="handleListPage" />

      <!-- 添加 OR 修改 -->
      <KoiDrawer
        ref="koiDrawerRef"
        :title="title"
        @koiConfirm="handleConfirm"
        @koiCancel="handleCancel"
        :loading="confirmLoading"
      >
        <template #content>
          <el-form ref="formRef" :rules="rules" :model="form" label-width="80px" status-icon>
            <el-row>
              <el-col :sm="{ span: 24 }" :xs="{ span: 24 }">
                <el-form-item label="岗位名称" prop="postName">
                  <el-input v-model="form.postName" placeholder="请输入岗位名称" clearable />
                </el-form-item>
              </el-col>
              <el-col :sm="{ span: 24 }" :xs="{ span: 24 }">
                <el-form-item label="岗位编码" prop="postCode">
                  <el-input v-model="form.postCode" placeholder="请输入岗位编码" clearable />
                </el-form-item>
              </el-col>
              <el-col :sm="{ span: 24 }" :xs="{ span: 24 }">
                <el-form-item label="岗位状态" prop="status">
                  <el-select v-model="form.status" placeholder="请选择岗位状态" clearable>
                    <el-option
                      v-for="dict in koiDicts.sys_normal_disable"
                      :key="dict.dictValue"
                      :label="dict.dictLabel"
                      :value="dict.dictValue"
                    />
                  </el-select>
                </el-form-item>
              </el-col>
              <el-col :sm="{ span: 24 }" :xs="{ span: 24 }">
                <el-form-item label="排序" prop="postSort">
                  <el-input-number v-model="form.postSort" :min="0" :step="1" placeholder="请输入数字"></el-input-number>
                </el-form-item>
              </el-col>
              <el-col :sm="{ span: 24 }" :xs="{ span: 24 }">
                <el-form-item label="岗位备注" prop="remark">
                  <el-input v-model="form.remark" :rows="5" type="textarea" placeholder="请输入岗位备注" />
                </el-form-item>
              </el-col>
            </el-row>
          </el-form>
        </template>
      </KoiDrawer>
    </KoiCard>
  </div>
</template>

<script setup lang="ts" name="post">
import { nextTick, ref, reactive, onMounted } from "vue";
import {
  koiMsgSuccess,
  koiNoticeSuccess,
  koiNoticeError,
  koiMsgError,
  koiMsgWarning,
  koiMsgBox,
  koiMsgInfo
} from "@/utils/koi.ts";
import { listPost, getPost, delPost, addPost, updatePost } from "@/api/system/post/index.ts";
import {useKoiDict} from "@/hooks/dicts";
import {download} from "@/utils/request.ts";

const { koiDicts } = useKoiDict(["sys_normal_disable"])
// 表格加载动画Loading
const loading = ref(false);
// 是否显示搜索表单[默认显示]
const showSearch = ref<boolean>(true); // 默认显示搜索条件
// 表格数据
const tableList = ref<any>([]);

// 查询参数
const searchParams = ref({
  pageNo: 1, // 第几页
  pageSize: 15, // 每页显示多少条
  postName: "",
  postCode: "",
  status: ""
});

const total = ref<number>(0);

/** 重置搜索参数 */
const resetSearchParams = () => {
  searchParams.value = {
    pageNo: 1,
    pageSize: 15,
    postName: "",
    postCode: "",
    status: ""
  };
};

/** 搜索 */
const handleSearch = () => {
  console.log("搜索");
  searchParams.value.pageNo = 1;
  handleListPage();
};

/** 重置 */
const resetSearch = () => {
  resetSearchParams();
  handleListPage();
};

/** @current-change：点击分页组件页码发生变化：例如：切换第2、3页 OR 上一页 AND 下一页 OR 跳转某一页 */
/** @size-change：点击分页组件下拉选择条数发生变化：例如：选择10条/页、20条/页等 */
// 分页查询，@current-change AND @size-change都会触发分页，调用后端分页接口
/** 数据表格 */
const handleListPage = async () => {
    loading.value = true;
    const res: any = await listPost(searchParams.value);
    if(res.code === 200) {
      tableList.value = res.rows;
      total.value = res.total;
    } else {
      loading.value = false;
      koiNoticeError("数据查询失败，请刷新重试");
    }
    loading.value = false
}

onMounted(() => {
  // 获取表格数据
  handleListPage();
});

const ids = ref([]); // 选择数组
const single = ref<boolean>(true); // 非单个禁用
const multiple = ref<boolean>(true); // 非多个禁用

/** 是否多选 */
const handleSelectionChange = (selection: any) => {
  ids.value = selection.map((item: any) => item.postId);
  single.value = selection.length != 1; // 单选
  multiple.value = !selection.length; // 多选
};

/** 添加 */
const handleAdd = () => {
  // 打开抽屉
  koiDrawerRef.value.koiOpen();
  koiMsgSuccess("添加");
  // 重置表单
  resetForm();
  // 标题
  title.value = "岗位添加";
  form.value.status = "0";
};

/** 修改 */
const handleUpdate = async (row?: any) => {
  const postId: any = row ? row.postId : ids.value[0];
  if (postId == null || postId == "") {
    return koiMsgError("请选择需要修改的数据");
  }
  koiMsgSuccess("修改");
  // 重置表单
  resetForm();
  // 标题
  title.value = "岗位修改";
  const res: any = await getPost(postId)
  if(res.code === 200) {
    form.value = res.data;
  }
  // 打开抽屉
  koiDrawerRef.value.koiOpen();
};

// 添加 OR 修改抽屉Ref
const koiDrawerRef = ref();
// 标题
const title = ref("岗位类型管理");
// form表单Ref
const formRef = ref<any>();

// form表单
let form = ref<any>({
  postName: "",
  postCode: "",
  status: "",
  postSort: 1,
  remark: ""
});

/** 清空表单数据 */
const resetForm = () => {
  // 等待 DOM 更新完成
  nextTick(() => {
    if (formRef.value) {
      // 重置该表单项，将其值重置为初始值，并移除校验结果
      formRef.value.resetFields();
    }
  });
  form.value = {
    postName: "",
    postCode: "",
    status: "",
    postSort: 1,
    remark: ""
  };
};

/** 表单规则 */
const rules = reactive({
  postName: [{ required: true, message: "请输入岗位名字", trigger: "blur" }],
  postCode: [{ required: true, message: "请输入岗位编码", trigger: "blur" }],
  status: [{ required: true, message: "请输入选择岗位状态", trigger: "blur" }]
});

// 确定按钮是否显示Loading
const confirmLoading = ref(false);

/** 确定  */
const handleConfirm = () => {
  if (!formRef.value) return;
  confirmLoading.value = true;
  (formRef.value as any).validate(async (valid: any) => {
    if (valid) {
      if (form.value.postId != null && form.value.postId != "") {
          const res: any = await updatePost(form.value);
          if(res.code === 200) {
            koiNoticeSuccess("修改成功");
            confirmLoading.value = false;
            koiDrawerRef.value.koiQuickClose();
            resetForm();
            handleListPage();
          } else {
            confirmLoading.value = false;
            koiNoticeError(res.msg);
          }
      } else {
        const res: any = await addPost(form.value);
        if(res.code === 200) {
          koiNoticeSuccess("添加成功");
          confirmLoading.value = false;
          koiDrawerRef.value.koiQuickClose();
          resetForm();
          handleListPage();
        } else {
          confirmLoading.value = false;
          koiNoticeError(res.msg);
        }
      }
    } else {
      koiMsgError("验证失败，请检查填写内容");
      confirmLoading.value = false;
    }
  });
};

/** 取消 */
const handleCancel = () => {
  koiDrawerRef.value.koiClose();
};

/** 删除 */
const handleDelete = (row: any) => {
  const id = row.postId;
  if (id == null || id == "") {
    koiMsgWarning("请选择需要删除的数据");
    return;
  }
  koiMsgBox("您确认需要删除岗位名称[" + row.postName + "]么？")
    .then(async () => {
      const res: any = await delPost(id);
      if(res.code === 200) {
        koiNoticeSuccess("删除成功");
        handleListPage();
      } else {
        koiNoticeError(res.mag);
      }
    })
    .catch(() => {
      koiMsgError("已取消");
    });
};

const handleExport = async () => {
  const query = searchParams.value
  koiMsgBox("确定导出？")
    .then(() => {
      download('system/post/export', query,`岗位信息_${new Date().getTime()}.xlsx`)
    });
}
</script>

<style lang="scss" scoped></style>
